/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pv168.locales;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.math.BigDecimal;
import java.text.Collator;
import java.text.DateFormat;
import java.text.NumberFormat;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Currency;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

/**
 *
 * @author bar
 */
public class Demo {

    private static final Logger logger = Logger.getLogger(Demo.class.getName());
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            ResourceBundle strings =  ResourceBundle.getBundle("cz.muni.fi.pv168.locales.strings");
            System.out.println(strings.getString("greating"));
            NumberFormat formater = NumberFormat.getCurrencyInstance();
            Currency kc = Currency.getInstance(new Locale("cs","CZ"));
            logger.addHandler(new FileHandler("demo.log"));
            formater.setCurrency(kc);
            BigDecimal sum = BigDecimal.ZERO;
            BigDecimal haler = new BigDecimal("0.01");
            System.out.println(formater.format(haler));
            for(int i=0;i<100;i++){
                sum = sum.add(haler);
                System.out.println(formater.format(sum));
            }
            
            Calendar cal = new GregorianCalendar();
            
            showLocalTime(strings, cal.getTime());
            
            String names[] = {"Cecílie","Cyril","Chrudoš","Svatava","Šárka"};
            Collator collator = Collator.getInstance();
            Arrays.sort(names,collator);
            System.out.println(Arrays.asList(names));
            logger.log(Level.INFO,"Writtin names to file:",Arrays.asList(names));
            writeToFile("names.txt",names);
        } catch (IOException | SecurityException ex) {
            logger.log(Level.SEVERE, null, ex);
        }
        
        
    }

    private static void showLocalTime(ResourceBundle bundle,Date time) {
        DateFormat format = DateFormat.getDateTimeInstance(DateFormat.FULL, DateFormat.FULL);
        System.out.println(bundle.getString("dateTime")+": "+format.format(time));
    }

    private static void writeToFile(String filename, String[] names) {
        try(BufferedWriter writer= new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename),System.getProperty("file.encoding")))) {
            for(String name:names){
                writer.write(name);
                writer.newLine();
            }
        } catch (UnsupportedEncodingException | FileNotFoundException ex) {
            logger.log(Level.SEVERE, "File not fount or unsupported encoding is used.", ex);
        } catch (IOException ex) {
            logger.log(Level.SEVERE, null, ex);
        }
    }
}
